> ## Documentation Index
> Fetch the complete documentation index at: https://docs.uselotus.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Create a customer

> Create a customer

<CodeGroup>
  ```py Python theme={null}
  lotus.create_customer(
      customer_id='cust_0569173ee6654369',
      email="corporation@outlook.com",
      name='Corporation Inc.',
  )
  ```

  ```ts Typescript theme={null}
  await lotus.createCustomer({
    customer_id: "123",
    email: "email@email.com",
    customer_name: "Test Customer",
  });
  ```
</CodeGroup>


## OpenAPI

````yaml POST /api/customers/
openapi: 3.0.3
info:
  title: Lotus API
  version: 0.9.3
  description: >-
    Lotus is an open-core pricing and billing engine. We enable API companies to
    automate and optimize their custom usage-based pricing for any metric.
servers: []
security: []
paths:
  /api/customers/:
    post:
      tags:
        - api
      operationId: api_customers_create
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/CustomerCreateRequest'
          application/x-www-form-urlencoded:
            schema:
              $ref: '#/components/schemas/CustomerCreateRequest'
          multipart/form-data:
            schema:
              $ref: '#/components/schemas/CustomerCreateRequest'
        required: true
      responses:
        '201':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Customer'
          description: ''
      security:
        - knoxTokenAuth: []
        - OrganizationApiKeyAuth: []
          TokenAuth: []
components:
  schemas:
    CustomerCreateRequest:
      type: object
      properties:
        customer_name:
          type: string
          nullable: true
          description: The display name of the customer
          maxLength: 100
        customer_id:
          type: string
          nullable: true
          minLength: 1
          description: >-
            The id provided when creating the customer, we suggest matching with
            your internal customer id in your backend
        email:
          type: string
          format: email
          minLength: 1
          description: >-
            The primary email address of the customer, must be the same as the
            email address used to create the customer in the payment provider
        payment_provider:
          enum:
            - stripe
            - braintree
          type: string
          description: >-
            The payment provider this customer is associated with. Currently,
            only Stripe is supported.


            * `stripe` - Stripe

            * `braintree` - Braintree
        payment_provider_id:
          type: string
          writeOnly: true
          nullable: true
          minLength: 1
          description: >-
            The customer's ID in the specified payment provider. Please note
            that payment_provider and payment_provider_id are mutually
            necessary.
        properties:
          type: object
          additionalProperties: {}
          nullable: true
          description: Extra metadata for the customer
        default_currency_code:
          type: string
          minLength: 1
          writeOnly: true
          description: >-
            The currency code this customer will be invoiced in. Codes are 3
            letters, e.g. 'USD'.
        address:
          allOf:
            - $ref: '#/components/schemas/AddressRequest'
          nullable: true
          deprecated: true
        billing_address:
          allOf:
            - $ref: '#/components/schemas/AddressRequest'
          nullable: true
        shipping_address:
          allOf:
            - $ref: '#/components/schemas/AddressRequest'
          nullable: true
        tax_rate:
          type: number
          format: double
          maximum: 999.9999
          minimum: 0
          nullable: true
          description: Tax rate as percentage. For example, 10.5 for 10.5%
      required:
        - customer_id
        - email
    Customer:
      type: object
      properties:
        customer_id:
          type: string
        email:
          type: string
          format: email
          nullable: true
        customer_name:
          type: string
          readOnly: true
          nullable: true
          description: The display name of the customer
        invoices:
          type: array
          items:
            $ref: '#/components/schemas/LightweightInvoice'
          readOnly: true
        total_amount_due:
          type: number
          format: double
          readOnly: true
        subscriptions:
          type: array
          items:
            $ref: '#/components/schemas/SubscriptionRecord'
          readOnly: true
        integrations:
          allOf:
            - $ref: '#/components/schemas/CustomerIntegrations'
          readOnly: true
          description: >-
            A dictionary containing the customer's integrations. Keys are the
            integration type, and the value is a dictionary containing the
            integration's properties, which can vary by integration.
        default_currency:
          $ref: '#/components/schemas/PricingUnit'
        payment_provider:
          enum:
            - stripe
            - braintree
            - null
          type: string
          description: |-
            * `stripe` - Stripe
            * `braintree` - Braintree
          nullable: true
        payment_provider_id:
          type: string
          nullable: true
          readOnly: true
        has_payment_method:
          type: boolean
          readOnly: true
        address:
          allOf:
            - $ref: '#/components/schemas/Address'
          nullable: true
          readOnly: true
          deprecated: true
        billing_address:
          allOf:
            - $ref: '#/components/schemas/Address'
          nullable: true
          readOnly: true
        shipping_address:
          allOf:
            - $ref: '#/components/schemas/Address'
          nullable: true
          readOnly: true
        tax_rate:
          type: number
          format: double
          maximum: 1000
          minimum: -1000
          exclusiveMaximum: true
          exclusiveMinimum: true
          readOnly: true
          nullable: true
          description: Tax rate as percentage. For example, 10.5 for 10.5%
        timezone:
          enum:
            - Africa/Abidjan
            - Africa/Accra
            - Africa/Addis_Ababa
            - Africa/Algiers
            - Africa/Asmara
            - Africa/Bamako
            - Africa/Bangui
            - Africa/Banjul
            - Africa/Bissau
            - Africa/Blantyre
            - Africa/Brazzaville
            - Africa/Bujumbura
            - Africa/Cairo
            - Africa/Casablanca
            - Africa/Ceuta
            - Africa/Conakry
            - Africa/Dakar
            - Africa/Dar_es_Salaam
            - Africa/Djibouti
            - Africa/Douala
            - Africa/El_Aaiun
            - Africa/Freetown
            - Africa/Gaborone
            - Africa/Harare
            - Africa/Johannesburg
            - Africa/Juba
            - Africa/Kampala
            - Africa/Khartoum
            - Africa/Kigali
            - Africa/Kinshasa
            - Africa/Lagos
            - Africa/Libreville
            - Africa/Lome
            - Africa/Luanda
            - Africa/Lubumbashi
            - Africa/Lusaka
            - Africa/Malabo
            - Africa/Maputo
            - Africa/Maseru
            - Africa/Mbabane
            - Africa/Mogadishu
            - Africa/Monrovia
            - Africa/Nairobi
            - Africa/Ndjamena
            - Africa/Niamey
            - Africa/Nouakchott
            - Africa/Ouagadougou
            - Africa/Porto-Novo
            - Africa/Sao_Tome
            - Africa/Tripoli
            - Africa/Tunis
            - Africa/Windhoek
            - America/Adak
            - America/Anchorage
            - America/Anguilla
            - America/Antigua
            - America/Araguaina
            - America/Argentina/Buenos_Aires
            - America/Argentina/Catamarca
            - America/Argentina/Cordoba
            - America/Argentina/Jujuy
            - America/Argentina/La_Rioja
            - America/Argentina/Mendoza
            - America/Argentina/Rio_Gallegos
            - America/Argentina/Salta
            - America/Argentina/San_Juan
            - America/Argentina/San_Luis
            - America/Argentina/Tucuman
            - America/Argentina/Ushuaia
            - America/Aruba
            - America/Asuncion
            - America/Atikokan
            - America/Bahia
            - America/Bahia_Banderas
            - America/Barbados
            - America/Belem
            - America/Belize
            - America/Blanc-Sablon
            - America/Boa_Vista
            - America/Bogota
            - America/Boise
            - America/Cambridge_Bay
            - America/Campo_Grande
            - America/Cancun
            - America/Caracas
            - America/Cayenne
            - America/Cayman
            - America/Chicago
            - America/Chihuahua
            - America/Ciudad_Juarez
            - America/Costa_Rica
            - America/Creston
            - America/Cuiaba
            - America/Curacao
            - America/Danmarkshavn
            - America/Dawson
            - America/Dawson_Creek
            - America/Denver
            - America/Detroit
            - America/Dominica
            - America/Edmonton
            - America/Eirunepe
            - America/El_Salvador
            - America/Fort_Nelson
            - America/Fortaleza
            - America/Glace_Bay
            - America/Goose_Bay
            - America/Grand_Turk
            - America/Grenada
            - America/Guadeloupe
            - America/Guatemala
            - America/Guayaquil
            - America/Guyana
            - America/Halifax
            - America/Havana
            - America/Hermosillo
            - America/Indiana/Indianapolis
            - America/Indiana/Knox
            - America/Indiana/Marengo
            - America/Indiana/Petersburg
            - America/Indiana/Tell_City
            - America/Indiana/Vevay
            - America/Indiana/Vincennes
            - America/Indiana/Winamac
            - America/Inuvik
            - America/Iqaluit
            - America/Jamaica
            - America/Juneau
            - America/Kentucky/Louisville
            - America/Kentucky/Monticello
            - America/Kralendijk
            - America/La_Paz
            - America/Lima
            - America/Los_Angeles
            - America/Lower_Princes
            - America/Maceio
            - America/Managua
            - America/Manaus
            - America/Marigot
            - America/Martinique
            - America/Matamoros
            - America/Mazatlan
            - America/Menominee
            - America/Merida
            - America/Metlakatla
            - America/Mexico_City
            - America/Miquelon
            - America/Moncton
            - America/Monterrey
            - America/Montevideo
            - America/Montserrat
            - America/Nassau
            - America/New_York
            - America/Nome
            - America/Noronha
            - America/North_Dakota/Beulah
            - America/North_Dakota/Center
            - America/North_Dakota/New_Salem
            - America/Nuuk
            - America/Ojinaga
            - America/Panama
            - America/Paramaribo
            - America/Phoenix
            - America/Port-au-Prince
            - America/Port_of_Spain
            - America/Porto_Velho
            - America/Puerto_Rico
            - America/Punta_Arenas
            - America/Rankin_Inlet
            - America/Recife
            - America/Regina
            - America/Resolute
            - America/Rio_Branco
            - America/Santarem
            - America/Santiago
            - America/Santo_Domingo
            - America/Sao_Paulo
            - America/Scoresbysund
            - America/Sitka
            - America/St_Barthelemy
            - America/St_Johns
            - America/St_Kitts
            - America/St_Lucia
            - America/St_Thomas
            - America/St_Vincent
            - America/Swift_Current
            - America/Tegucigalpa
            - America/Thule
            - America/Tijuana
            - America/Toronto
            - America/Tortola
            - America/Vancouver
            - America/Whitehorse
            - America/Winnipeg
            - America/Yakutat
            - America/Yellowknife
            - Antarctica/Casey
            - Antarctica/Davis
            - Antarctica/DumontDUrville
            - Antarctica/Macquarie
            - Antarctica/Mawson
            - Antarctica/McMurdo
            - Antarctica/Palmer
            - Antarctica/Rothera
            - Antarctica/Syowa
            - Antarctica/Troll
            - Antarctica/Vostok
            - Arctic/Longyearbyen
            - Asia/Aden
            - Asia/Almaty
            - Asia/Amman
            - Asia/Anadyr
            - Asia/Aqtau
            - Asia/Aqtobe
            - Asia/Ashgabat
            - Asia/Atyrau
            - Asia/Baghdad
            - Asia/Bahrain
            - Asia/Baku
            - Asia/Bangkok
            - Asia/Barnaul
            - Asia/Beirut
            - Asia/Bishkek
            - Asia/Brunei
            - Asia/Chita
            - Asia/Choibalsan
            - Asia/Colombo
            - Asia/Damascus
            - Asia/Dhaka
            - Asia/Dili
            - Asia/Dubai
            - Asia/Dushanbe
            - Asia/Famagusta
            - Asia/Gaza
            - Asia/Hebron
            - Asia/Ho_Chi_Minh
            - Asia/Hong_Kong
            - Asia/Hovd
            - Asia/Irkutsk
            - Asia/Jakarta
            - Asia/Jayapura
            - Asia/Jerusalem
            - Asia/Kabul
            - Asia/Kamchatka
            - Asia/Karachi
            - Asia/Kathmandu
            - Asia/Khandyga
            - Asia/Kolkata
            - Asia/Krasnoyarsk
            - Asia/Kuala_Lumpur
            - Asia/Kuching
            - Asia/Kuwait
            - Asia/Macau
            - Asia/Magadan
            - Asia/Makassar
            - Asia/Manila
            - Asia/Muscat
            - Asia/Nicosia
            - Asia/Novokuznetsk
            - Asia/Novosibirsk
            - Asia/Omsk
            - Asia/Oral
            - Asia/Phnom_Penh
            - Asia/Pontianak
            - Asia/Pyongyang
            - Asia/Qatar
            - Asia/Qostanay
            - Asia/Qyzylorda
            - Asia/Riyadh
            - Asia/Sakhalin
            - Asia/Samarkand
            - Asia/Seoul
            - Asia/Shanghai
            - Asia/Singapore
            - Asia/Srednekolymsk
            - Asia/Taipei
            - Asia/Tashkent
            - Asia/Tbilisi
            - Asia/Tehran
            - Asia/Thimphu
            - Asia/Tokyo
            - Asia/Tomsk
            - Asia/Ulaanbaatar
            - Asia/Urumqi
            - Asia/Ust-Nera
            - Asia/Vientiane
            - Asia/Vladivostok
            - Asia/Yakutsk
            - Asia/Yangon
            - Asia/Yekaterinburg
            - Asia/Yerevan
            - Atlantic/Azores
            - Atlantic/Bermuda
            - Atlantic/Canary
            - Atlantic/Cape_Verde
            - Atlantic/Faroe
            - Atlantic/Madeira
            - Atlantic/Reykjavik
            - Atlantic/South_Georgia
            - Atlantic/St_Helena
            - Atlantic/Stanley
            - Australia/Adelaide
            - Australia/Brisbane
            - Australia/Broken_Hill
            - Australia/Darwin
            - Australia/Eucla
            - Australia/Hobart
            - Australia/Lindeman
            - Australia/Lord_Howe
            - Australia/Melbourne
            - Australia/Perth
            - Australia/Sydney
            - Canada/Atlantic
            - Canada/Central
            - Canada/Eastern
            - Canada/Mountain
            - Canada/Newfoundland
            - Canada/Pacific
            - Europe/Amsterdam
            - Europe/Andorra
            - Europe/Astrakhan
            - Europe/Athens
            - Europe/Belgrade
            - Europe/Berlin
            - Europe/Bratislava
            - Europe/Brussels
            - Europe/Bucharest
            - Europe/Budapest
            - Europe/Busingen
            - Europe/Chisinau
            - Europe/Copenhagen
            - Europe/Dublin
            - Europe/Gibraltar
            - Europe/Guernsey
            - Europe/Helsinki
            - Europe/Isle_of_Man
            - Europe/Istanbul
            - Europe/Jersey
            - Europe/Kaliningrad
            - Europe/Kirov
            - Europe/Kyiv
            - Europe/Lisbon
            - Europe/Ljubljana
            - Europe/London
            - Europe/Luxembourg
            - Europe/Madrid
            - Europe/Malta
            - Europe/Mariehamn
            - Europe/Minsk
            - Europe/Monaco
            - Europe/Moscow
            - Europe/Oslo
            - Europe/Paris
            - Europe/Podgorica
            - Europe/Prague
            - Europe/Riga
            - Europe/Rome
            - Europe/Samara
            - Europe/San_Marino
            - Europe/Sarajevo
            - Europe/Saratov
            - Europe/Simferopol
            - Europe/Skopje
            - Europe/Sofia
            - Europe/Stockholm
            - Europe/Tallinn
            - Europe/Tirane
            - Europe/Ulyanovsk
            - Europe/Vaduz
            - Europe/Vatican
            - Europe/Vienna
            - Europe/Vilnius
            - Europe/Volgograd
            - Europe/Warsaw
            - Europe/Zagreb
            - Europe/Zurich
            - GMT
            - Indian/Antananarivo
            - Indian/Chagos
            - Indian/Christmas
            - Indian/Cocos
            - Indian/Comoro
            - Indian/Kerguelen
            - Indian/Mahe
            - Indian/Maldives
            - Indian/Mauritius
            - Indian/Mayotte
            - Indian/Reunion
            - Pacific/Apia
            - Pacific/Auckland
            - Pacific/Bougainville
            - Pacific/Chatham
            - Pacific/Chuuk
            - Pacific/Easter
            - Pacific/Efate
            - Pacific/Fakaofo
            - Pacific/Fiji
            - Pacific/Funafuti
            - Pacific/Galapagos
            - Pacific/Gambier
            - Pacific/Guadalcanal
            - Pacific/Guam
            - Pacific/Honolulu
            - Pacific/Kanton
            - Pacific/Kiritimati
            - Pacific/Kosrae
            - Pacific/Kwajalein
            - Pacific/Majuro
            - Pacific/Marquesas
            - Pacific/Midway
            - Pacific/Nauru
            - Pacific/Niue
            - Pacific/Norfolk
            - Pacific/Noumea
            - Pacific/Pago_Pago
            - Pacific/Palau
            - Pacific/Pitcairn
            - Pacific/Pohnpei
            - Pacific/Port_Moresby
            - Pacific/Rarotonga
            - Pacific/Saipan
            - Pacific/Tahiti
            - Pacific/Tarawa
            - Pacific/Tongatapu
            - Pacific/Wake
            - Pacific/Wallis
            - US/Alaska
            - US/Arizona
            - US/Central
            - US/Eastern
            - US/Hawaii
            - US/Mountain
            - US/Pacific
            - UTC
          type: string
          description: |-
            * `Africa/Abidjan` - Africa/Abidjan
            * `Africa/Accra` - Africa/Accra
            * `Africa/Addis_Ababa` - Africa/Addis_Ababa
            * `Africa/Algiers` - Africa/Algiers
            * `Africa/Asmara` - Africa/Asmara
            * `Africa/Bamako` - Africa/Bamako
            * `Africa/Bangui` - Africa/Bangui
            * `Africa/Banjul` - Africa/Banjul
            * `Africa/Bissau` - Africa/Bissau
            * `Africa/Blantyre` - Africa/Blantyre
            * `Africa/Brazzaville` - Africa/Brazzaville
            * `Africa/Bujumbura` - Africa/Bujumbura
            * `Africa/Cairo` - Africa/Cairo
            * `Africa/Casablanca` - Africa/Casablanca
            * `Africa/Ceuta` - Africa/Ceuta
            * `Africa/Conakry` - Africa/Conakry
            * `Africa/Dakar` - Africa/Dakar
            * `Africa/Dar_es_Salaam` - Africa/Dar_es_Salaam
            * `Africa/Djibouti` - Africa/Djibouti
            * `Africa/Douala` - Africa/Douala
            * `Africa/El_Aaiun` - Africa/El_Aaiun
            * `Africa/Freetown` - Africa/Freetown
            * `Africa/Gaborone` - Africa/Gaborone
            * `Africa/Harare` - Africa/Harare
            * `Africa/Johannesburg` - Africa/Johannesburg
            * `Africa/Juba` - Africa/Juba
            * `Africa/Kampala` - Africa/Kampala
            * `Africa/Khartoum` - Africa/Khartoum
            * `Africa/Kigali` - Africa/Kigali
            * `Africa/Kinshasa` - Africa/Kinshasa
            * `Africa/Lagos` - Africa/Lagos
            * `Africa/Libreville` - Africa/Libreville
            * `Africa/Lome` - Africa/Lome
            * `Africa/Luanda` - Africa/Luanda
            * `Africa/Lubumbashi` - Africa/Lubumbashi
            * `Africa/Lusaka` - Africa/Lusaka
            * `Africa/Malabo` - Africa/Malabo
            * `Africa/Maputo` - Africa/Maputo
            * `Africa/Maseru` - Africa/Maseru
            * `Africa/Mbabane` - Africa/Mbabane
            * `Africa/Mogadishu` - Africa/Mogadishu
            * `Africa/Monrovia` - Africa/Monrovia
            * `Africa/Nairobi` - Africa/Nairobi
            * `Africa/Ndjamena` - Africa/Ndjamena
            * `Africa/Niamey` - Africa/Niamey
            * `Africa/Nouakchott` - Africa/Nouakchott
            * `Africa/Ouagadougou` - Africa/Ouagadougou
            * `Africa/Porto-Novo` - Africa/Porto-Novo
            * `Africa/Sao_Tome` - Africa/Sao_Tome
            * `Africa/Tripoli` - Africa/Tripoli
            * `Africa/Tunis` - Africa/Tunis
            * `Africa/Windhoek` - Africa/Windhoek
            * `America/Adak` - America/Adak
            * `America/Anchorage` - America/Anchorage
            * `America/Anguilla` - America/Anguilla
            * `America/Antigua` - America/Antigua
            * `America/Araguaina` - America/Araguaina
            * `America/Argentina/Buenos_Aires` - America/Argentina/Buenos_Aires
            * `America/Argentina/Catamarca` - America/Argentina/Catamarca
            * `America/Argentina/Cordoba` - America/Argentina/Cordoba
            * `America/Argentina/Jujuy` - America/Argentina/Jujuy
            * `America/Argentina/La_Rioja` - America/Argentina/La_Rioja
            * `America/Argentina/Mendoza` - America/Argentina/Mendoza
            * `America/Argentina/Rio_Gallegos` - America/Argentina/Rio_Gallegos
            * `America/Argentina/Salta` - America/Argentina/Salta
            * `America/Argentina/San_Juan` - America/Argentina/San_Juan
            * `America/Argentina/San_Luis` - America/Argentina/San_Luis
            * `America/Argentina/Tucuman` - America/Argentina/Tucuman
            * `America/Argentina/Ushuaia` - America/Argentina/Ushuaia
            * `America/Aruba` - America/Aruba
            * `America/Asuncion` - America/Asuncion
            * `America/Atikokan` - America/Atikokan
            * `America/Bahia` - America/Bahia
            * `America/Bahia_Banderas` - America/Bahia_Banderas
            * `America/Barbados` - America/Barbados
            * `America/Belem` - America/Belem
            * `America/Belize` - America/Belize
            * `America/Blanc-Sablon` - America/Blanc-Sablon
            * `America/Boa_Vista` - America/Boa_Vista
            * `America/Bogota` - America/Bogota
            * `America/Boise` - America/Boise
            * `America/Cambridge_Bay` - America/Cambridge_Bay
            * `America/Campo_Grande` - America/Campo_Grande
            * `America/Cancun` - America/Cancun
            * `America/Caracas` - America/Caracas
            * `America/Cayenne` - America/Cayenne
            * `America/Cayman` - America/Cayman
            * `America/Chicago` - America/Chicago
            * `America/Chihuahua` - America/Chihuahua
            * `America/Ciudad_Juarez` - America/Ciudad_Juarez
            * `America/Costa_Rica` - America/Costa_Rica
            * `America/Creston` - America/Creston
            * `America/Cuiaba` - America/Cuiaba
            * `America/Curacao` - America/Curacao
            * `America/Danmarkshavn` - America/Danmarkshavn
            * `America/Dawson` - America/Dawson
            * `America/Dawson_Creek` - America/Dawson_Creek
            * `America/Denver` - America/Denver
            * `America/Detroit` - America/Detroit
            * `America/Dominica` - America/Dominica
            * `America/Edmonton` - America/Edmonton
            * `America/Eirunepe` - America/Eirunepe
            * `America/El_Salvador` - America/El_Salvador
            * `America/Fort_Nelson` - America/Fort_Nelson
            * `America/Fortaleza` - America/Fortaleza
            * `America/Glace_Bay` - America/Glace_Bay
            * `America/Goose_Bay` - America/Goose_Bay
            * `America/Grand_Turk` - America/Grand_Turk
            * `America/Grenada` - America/Grenada
            * `America/Guadeloupe` - America/Guadeloupe
            * `America/Guatemala` - America/Guatemala
            * `America/Guayaquil` - America/Guayaquil
            * `America/Guyana` - America/Guyana
            * `America/Halifax` - America/Halifax
            * `America/Havana` - America/Havana
            * `America/Hermosillo` - America/Hermosillo
            * `America/Indiana/Indianapolis` - America/Indiana/Indianapolis
            * `America/Indiana/Knox` - America/Indiana/Knox
            * `America/Indiana/Marengo` - America/Indiana/Marengo
            * `America/Indiana/Petersburg` - America/Indiana/Petersburg
            * `America/Indiana/Tell_City` - America/Indiana/Tell_City
            * `America/Indiana/Vevay` - America/Indiana/Vevay
            * `America/Indiana/Vincennes` - America/Indiana/Vincennes
            * `America/Indiana/Winamac` - America/Indiana/Winamac
            * `America/Inuvik` - America/Inuvik
            * `America/Iqaluit` - America/Iqaluit
            * `America/Jamaica` - America/Jamaica
            * `America/Juneau` - America/Juneau
            * `America/Kentucky/Louisville` - America/Kentucky/Louisville
            * `America/Kentucky/Monticello` - America/Kentucky/Monticello
            * `America/Kralendijk` - America/Kralendijk
            * `America/La_Paz` - America/La_Paz
            * `America/Lima` - America/Lima
            * `America/Los_Angeles` - America/Los_Angeles
            * `America/Lower_Princes` - America/Lower_Princes
            * `America/Maceio` - America/Maceio
            * `America/Managua` - America/Managua
            * `America/Manaus` - America/Manaus
            * `America/Marigot` - America/Marigot
            * `America/Martinique` - America/Martinique
            * `America/Matamoros` - America/Matamoros
            * `America/Mazatlan` - America/Mazatlan
            * `America/Menominee` - America/Menominee
            * `America/Merida` - America/Merida
            * `America/Metlakatla` - America/Metlakatla
            * `America/Mexico_City` - America/Mexico_City
            * `America/Miquelon` - America/Miquelon
            * `America/Moncton` - America/Moncton
            * `America/Monterrey` - America/Monterrey
            * `America/Montevideo` - America/Montevideo
            * `America/Montserrat` - America/Montserrat
            * `America/Nassau` - America/Nassau
            * `America/New_York` - America/New_York
            * `America/Nome` - America/Nome
            * `America/Noronha` - America/Noronha
            * `America/North_Dakota/Beulah` - America/North_Dakota/Beulah
            * `America/North_Dakota/Center` - America/North_Dakota/Center
            * `America/North_Dakota/New_Salem` - America/North_Dakota/New_Salem
            * `America/Nuuk` - America/Nuuk
            * `America/Ojinaga` - America/Ojinaga
            * `America/Panama` - America/Panama
            * `America/Paramaribo` - America/Paramaribo
            * `America/Phoenix` - America/Phoenix
            * `America/Port-au-Prince` - America/Port-au-Prince
            * `America/Port_of_Spain` - America/Port_of_Spain
            * `America/Porto_Velho` - America/Porto_Velho
            * `America/Puerto_Rico` - America/Puerto_Rico
            * `America/Punta_Arenas` - America/Punta_Arenas
            * `America/Rankin_Inlet` - America/Rankin_Inlet
            * `America/Recife` - America/Recife
            * `America/Regina` - America/Regina
            * `America/Resolute` - America/Resolute
            * `America/Rio_Branco` - America/Rio_Branco
            * `America/Santarem` - America/Santarem
            * `America/Santiago` - America/Santiago
            * `America/Santo_Domingo` - America/Santo_Domingo
            * `America/Sao_Paulo` - America/Sao_Paulo
            * `America/Scoresbysund` - America/Scoresbysund
            * `America/Sitka` - America/Sitka
            * `America/St_Barthelemy` - America/St_Barthelemy
            * `America/St_Johns` - America/St_Johns
            * `America/St_Kitts` - America/St_Kitts
            * `America/St_Lucia` - America/St_Lucia
            * `America/St_Thomas` - America/St_Thomas
            * `America/St_Vincent` - America/St_Vincent
            * `America/Swift_Current` - America/Swift_Current
            * `America/Tegucigalpa` - America/Tegucigalpa
            * `America/Thule` - America/Thule
            * `America/Tijuana` - America/Tijuana
            * `America/Toronto` - America/Toronto
            * `America/Tortola` - America/Tortola
            * `America/Vancouver` - America/Vancouver
            * `America/Whitehorse` - America/Whitehorse
            * `America/Winnipeg` - America/Winnipeg
            * `America/Yakutat` - America/Yakutat
            * `America/Yellowknife` - America/Yellowknife
            * `Antarctica/Casey` - Antarctica/Casey
            * `Antarctica/Davis` - Antarctica/Davis
            * `Antarctica/DumontDUrville` - Antarctica/DumontDUrville
            * `Antarctica/Macquarie` - Antarctica/Macquarie
            * `Antarctica/Mawson` - Antarctica/Mawson
            * `Antarctica/McMurdo` - Antarctica/McMurdo
            * `Antarctica/Palmer` - Antarctica/Palmer
            * `Antarctica/Rothera` - Antarctica/Rothera
            * `Antarctica/Syowa` - Antarctica/Syowa
            * `Antarctica/Troll` - Antarctica/Troll
            * `Antarctica/Vostok` - Antarctica/Vostok
            * `Arctic/Longyearbyen` - Arctic/Longyearbyen
            * `Asia/Aden` - Asia/Aden
            * `Asia/Almaty` - Asia/Almaty
            * `Asia/Amman` - Asia/Amman
            * `Asia/Anadyr` - Asia/Anadyr
            * `Asia/Aqtau` - Asia/Aqtau
            * `Asia/Aqtobe` - Asia/Aqtobe
            * `Asia/Ashgabat` - Asia/Ashgabat
            * `Asia/Atyrau` - Asia/Atyrau
            * `Asia/Baghdad` - Asia/Baghdad
            * `Asia/Bahrain` - Asia/Bahrain
            * `Asia/Baku` - Asia/Baku
            * `Asia/Bangkok` - Asia/Bangkok
            * `Asia/Barnaul` - Asia/Barnaul
            * `Asia/Beirut` - Asia/Beirut
            * `Asia/Bishkek` - Asia/Bishkek
            * `Asia/Brunei` - Asia/Brunei
            * `Asia/Chita` - Asia/Chita
            * `Asia/Choibalsan` - Asia/Choibalsan
            * `Asia/Colombo` - Asia/Colombo
            * `Asia/Damascus` - Asia/Damascus
            * `Asia/Dhaka` - Asia/Dhaka
            * `Asia/Dili` - Asia/Dili
            * `Asia/Dubai` - Asia/Dubai
            * `Asia/Dushanbe` - Asia/Dushanbe
            * `Asia/Famagusta` - Asia/Famagusta
            * `Asia/Gaza` - Asia/Gaza
            * `Asia/Hebron` - Asia/Hebron
            * `Asia/Ho_Chi_Minh` - Asia/Ho_Chi_Minh
            * `Asia/Hong_Kong` - Asia/Hong_Kong
            * `Asia/Hovd` - Asia/Hovd
            * `Asia/Irkutsk` - Asia/Irkutsk
            * `Asia/Jakarta` - Asia/Jakarta
            * `Asia/Jayapura` - Asia/Jayapura
            * `Asia/Jerusalem` - Asia/Jerusalem
            * `Asia/Kabul` - Asia/Kabul
            * `Asia/Kamchatka` - Asia/Kamchatka
            * `Asia/Karachi` - Asia/Karachi
            * `Asia/Kathmandu` - Asia/Kathmandu
            * `Asia/Khandyga` - Asia/Khandyga
            * `Asia/Kolkata` - Asia/Kolkata
            * `Asia/Krasnoyarsk` - Asia/Krasnoyarsk
            * `Asia/Kuala_Lumpur` - Asia/Kuala_Lumpur
            * `Asia/Kuching` - Asia/Kuching
            * `Asia/Kuwait` - Asia/Kuwait
            * `Asia/Macau` - Asia/Macau
            * `Asia/Magadan` - Asia/Magadan
            * `Asia/Makassar` - Asia/Makassar
            * `Asia/Manila` - Asia/Manila
            * `Asia/Muscat` - Asia/Muscat
            * `Asia/Nicosia` - Asia/Nicosia
            * `Asia/Novokuznetsk` - Asia/Novokuznetsk
            * `Asia/Novosibirsk` - Asia/Novosibirsk
            * `Asia/Omsk` - Asia/Omsk
            * `Asia/Oral` - Asia/Oral
            * `Asia/Phnom_Penh` - Asia/Phnom_Penh
            * `Asia/Pontianak` - Asia/Pontianak
            * `Asia/Pyongyang` - Asia/Pyongyang
            * `Asia/Qatar` - Asia/Qatar
            * `Asia/Qostanay` - Asia/Qostanay
            * `Asia/Qyzylorda` - Asia/Qyzylorda
            * `Asia/Riyadh` - Asia/Riyadh
            * `Asia/Sakhalin` - Asia/Sakhalin
            * `Asia/Samarkand` - Asia/Samarkand
            * `Asia/Seoul` - Asia/Seoul
            * `Asia/Shanghai` - Asia/Shanghai
            * `Asia/Singapore` - Asia/Singapore
            * `Asia/Srednekolymsk` - Asia/Srednekolymsk
            * `Asia/Taipei` - Asia/Taipei
            * `Asia/Tashkent` - Asia/Tashkent
            * `Asia/Tbilisi` - Asia/Tbilisi
            * `Asia/Tehran` - Asia/Tehran
            * `Asia/Thimphu` - Asia/Thimphu
            * `Asia/Tokyo` - Asia/Tokyo
            * `Asia/Tomsk` - Asia/Tomsk
            * `Asia/Ulaanbaatar` - Asia/Ulaanbaatar
            * `Asia/Urumqi` - Asia/Urumqi
            * `Asia/Ust-Nera` - Asia/Ust-Nera
            * `Asia/Vientiane` - Asia/Vientiane
            * `Asia/Vladivostok` - Asia/Vladivostok
            * `Asia/Yakutsk` - Asia/Yakutsk
            * `Asia/Yangon` - Asia/Yangon
            * `Asia/Yekaterinburg` - Asia/Yekaterinburg
            * `Asia/Yerevan` - Asia/Yerevan
            * `Atlantic/Azores` - Atlantic/Azores
            * `Atlantic/Bermuda` - Atlantic/Bermuda
            * `Atlantic/Canary` - Atlantic/Canary
            * `Atlantic/Cape_Verde` - Atlantic/Cape_Verde
            * `Atlantic/Faroe` - Atlantic/Faroe
            * `Atlantic/Madeira` - Atlantic/Madeira
            * `Atlantic/Reykjavik` - Atlantic/Reykjavik
            * `Atlantic/South_Georgia` - Atlantic/South_Georgia
            * `Atlantic/St_Helena` - Atlantic/St_Helena
            * `Atlantic/Stanley` - Atlantic/Stanley
            * `Australia/Adelaide` - Australia/Adelaide
            * `Australia/Brisbane` - Australia/Brisbane
            * `Australia/Broken_Hill` - Australia/Broken_Hill
            * `Australia/Darwin` - Australia/Darwin
            * `Australia/Eucla` - Australia/Eucla
            * `Australia/Hobart` - Australia/Hobart
            * `Australia/Lindeman` - Australia/Lindeman
            * `Australia/Lord_Howe` - Australia/Lord_Howe
            * `Australia/Melbourne` - Australia/Melbourne
            * `Australia/Perth` - Australia/Perth
            * `Australia/Sydney` - Australia/Sydney
            * `Canada/Atlantic` - Canada/Atlantic
            * `Canada/Central` - Canada/Central
            * `Canada/Eastern` - Canada/Eastern
            * `Canada/Mountain` - Canada/Mountain
            * `Canada/Newfoundland` - Canada/Newfoundland
            * `Canada/Pacific` - Canada/Pacific
            * `Europe/Amsterdam` - Europe/Amsterdam
            * `Europe/Andorra` - Europe/Andorra
            * `Europe/Astrakhan` - Europe/Astrakhan
            * `Europe/Athens` - Europe/Athens
            * `Europe/Belgrade` - Europe/Belgrade
            * `Europe/Berlin` - Europe/Berlin
            * `Europe/Bratislava` - Europe/Bratislava
            * `Europe/Brussels` - Europe/Brussels
            * `Europe/Bucharest` - Europe/Bucharest
            * `Europe/Budapest` - Europe/Budapest
            * `Europe/Busingen` - Europe/Busingen
            * `Europe/Chisinau` - Europe/Chisinau
            * `Europe/Copenhagen` - Europe/Copenhagen
            * `Europe/Dublin` - Europe/Dublin
            * `Europe/Gibraltar` - Europe/Gibraltar
            * `Europe/Guernsey` - Europe/Guernsey
            * `Europe/Helsinki` - Europe/Helsinki
            * `Europe/Isle_of_Man` - Europe/Isle_of_Man
            * `Europe/Istanbul` - Europe/Istanbul
            * `Europe/Jersey` - Europe/Jersey
            * `Europe/Kaliningrad` - Europe/Kaliningrad
            * `Europe/Kirov` - Europe/Kirov
            * `Europe/Kyiv` - Europe/Kyiv
            * `Europe/Lisbon` - Europe/Lisbon
            * `Europe/Ljubljana` - Europe/Ljubljana
            * `Europe/London` - Europe/London
            * `Europe/Luxembourg` - Europe/Luxembourg
            * `Europe/Madrid` - Europe/Madrid
            * `Europe/Malta` - Europe/Malta
            * `Europe/Mariehamn` - Europe/Mariehamn
            * `Europe/Minsk` - Europe/Minsk
            * `Europe/Monaco` - Europe/Monaco
            * `Europe/Moscow` - Europe/Moscow
            * `Europe/Oslo` - Europe/Oslo
            * `Europe/Paris` - Europe/Paris
            * `Europe/Podgorica` - Europe/Podgorica
            * `Europe/Prague` - Europe/Prague
            * `Europe/Riga` - Europe/Riga
            * `Europe/Rome` - Europe/Rome
            * `Europe/Samara` - Europe/Samara
            * `Europe/San_Marino` - Europe/San_Marino
            * `Europe/Sarajevo` - Europe/Sarajevo
            * `Europe/Saratov` - Europe/Saratov
            * `Europe/Simferopol` - Europe/Simferopol
            * `Europe/Skopje` - Europe/Skopje
            * `Europe/Sofia` - Europe/Sofia
            * `Europe/Stockholm` - Europe/Stockholm
            * `Europe/Tallinn` - Europe/Tallinn
            * `Europe/Tirane` - Europe/Tirane
            * `Europe/Ulyanovsk` - Europe/Ulyanovsk
            * `Europe/Vaduz` - Europe/Vaduz
            * `Europe/Vatican` - Europe/Vatican
            * `Europe/Vienna` - Europe/Vienna
            * `Europe/Vilnius` - Europe/Vilnius
            * `Europe/Volgograd` - Europe/Volgograd
            * `Europe/Warsaw` - Europe/Warsaw
            * `Europe/Zagreb` - Europe/Zagreb
            * `Europe/Zurich` - Europe/Zurich
            * `GMT` - GMT
            * `Indian/Antananarivo` - Indian/Antananarivo
            * `Indian/Chagos` - Indian/Chagos
            * `Indian/Christmas` - Indian/Christmas
            * `Indian/Cocos` - Indian/Cocos
            * `Indian/Comoro` - Indian/Comoro
            * `Indian/Kerguelen` - Indian/Kerguelen
            * `Indian/Mahe` - Indian/Mahe
            * `Indian/Maldives` - Indian/Maldives
            * `Indian/Mauritius` - Indian/Mauritius
            * `Indian/Mayotte` - Indian/Mayotte
            * `Indian/Reunion` - Indian/Reunion
            * `Pacific/Apia` - Pacific/Apia
            * `Pacific/Auckland` - Pacific/Auckland
            * `Pacific/Bougainville` - Pacific/Bougainville
            * `Pacific/Chatham` - Pacific/Chatham
            * `Pacific/Chuuk` - Pacific/Chuuk
            * `Pacific/Easter` - Pacific/Easter
            * `Pacific/Efate` - Pacific/Efate
            * `Pacific/Fakaofo` - Pacific/Fakaofo
            * `Pacific/Fiji` - Pacific/Fiji
            * `Pacific/Funafuti` - Pacific/Funafuti
            * `Pacific/Galapagos` - Pacific/Galapagos
            * `Pacific/Gambier` - Pacific/Gambier
            * `Pacific/Guadalcanal` - Pacific/Guadalcanal
            * `Pacific/Guam` - Pacific/Guam
            * `Pacific/Honolulu` - Pacific/Honolulu
            * `Pacific/Kanton` - Pacific/Kanton
            * `Pacific/Kiritimati` - Pacific/Kiritimati
            * `Pacific/Kosrae` - Pacific/Kosrae
            * `Pacific/Kwajalein` - Pacific/Kwajalein
            * `Pacific/Majuro` - Pacific/Majuro
            * `Pacific/Marquesas` - Pacific/Marquesas
            * `Pacific/Midway` - Pacific/Midway
            * `Pacific/Nauru` - Pacific/Nauru
            * `Pacific/Niue` - Pacific/Niue
            * `Pacific/Norfolk` - Pacific/Norfolk
            * `Pacific/Noumea` - Pacific/Noumea
            * `Pacific/Pago_Pago` - Pacific/Pago_Pago
            * `Pacific/Palau` - Pacific/Palau
            * `Pacific/Pitcairn` - Pacific/Pitcairn
            * `Pacific/Pohnpei` - Pacific/Pohnpei
            * `Pacific/Port_Moresby` - Pacific/Port_Moresby
            * `Pacific/Rarotonga` - Pacific/Rarotonga
            * `Pacific/Saipan` - Pacific/Saipan
            * `Pacific/Tahiti` - Pacific/Tahiti
            * `Pacific/Tarawa` - Pacific/Tarawa
            * `Pacific/Tongatapu` - Pacific/Tongatapu
            * `Pacific/Wake` - Pacific/Wake
            * `Pacific/Wallis` - Pacific/Wallis
            * `US/Alaska` - US/Alaska
            * `US/Arizona` - US/Arizona
            * `US/Central` - US/Central
            * `US/Eastern` - US/Eastern
            * `US/Hawaii` - US/Hawaii
            * `US/Mountain` - US/Mountain
            * `US/Pacific` - US/Pacific
            * `UTC` - UTC
        tax_providers:
          type: array
          items:
            enum:
              - taxjar
              - lotus
              - netsuite
            description: |-
              * `taxjar` - taxjar
              * `lotus` - lotus
              * `netsuite` - netsuite
          readOnly: true
          description: >-
            A list of tax providers that are enabled for this customer. The list
            is ordered, meaning we will succesively try to calculate taxes using
            each provider until we find one that works.
      required:
        - billing_address
        - customer_id
        - customer_name
        - default_currency
        - email
        - has_payment_method
        - integrations
        - invoices
        - payment_provider
        - payment_provider_id
        - shipping_address
        - subscriptions
        - tax_providers
        - tax_rate
        - timezone
        - total_amount_due
    AddressRequest:
      type: object
      properties:
        city:
          type: string
          minLength: 1
          description: City, district, suburb, town, or village
          maxLength: 50
        country:
          enum:
            - AW
            - AF
            - AO
            - AI
            - AX
            - AL
            - AD
            - AE
            - AR
            - AM
            - AS
            - AQ
            - TF
            - AG
            - AU
            - AT
            - AZ
            - BI
            - BE
            - BJ
            - BQ
            - BF
            - BD
            - BG
            - BH
            - BS
            - BA
            - BL
            - BY
            - BZ
            - BM
            - BO
            - BR
            - BB
            - BN
            - BT
            - BV
            - BW
            - CF
            - CA
            - CC
            - CH
            - CL
            - CN
            - CI
            - CM
            - CD
            - CG
            - CK
            - CO
            - KM
            - CV
            - CR
            - CU
            - CW
            - CX
            - KY
            - CY
            - CZ
            - DE
            - DJ
            - DM
            - DK
            - DO
            - DZ
            - EC
            - EG
            - ER
            - EH
            - ES
            - EE
            - ET
            - FI
            - FJ
            - FK
            - FR
            - FO
            - FM
            - GA
            - GB
            - GE
            - GG
            - GH
            - GI
            - GN
            - GP
            - GM
            - GW
            - GQ
            - GR
            - GD
            - GL
            - GT
            - GF
            - GU
            - GY
            - HK
            - HM
            - HN
            - HR
            - HT
            - HU
            - ID
            - IM
            - IN
            - IO
            - IE
            - IR
            - IQ
            - IS
            - IL
            - IT
            - JM
            - JE
            - JO
            - JP
            - KZ
            - KE
            - KG
            - KH
            - KI
            - KN
            - KR
            - KW
            - LA
            - LB
            - LR
            - LY
            - LC
            - LI
            - LK
            - LS
            - LT
            - LU
            - LV
            - MO
            - MF
            - MA
            - MC
            - MD
            - MG
            - MV
            - MX
            - MH
            - MK
            - ML
            - MT
            - MM
            - ME
            - MN
            - MP
            - MZ
            - MR
            - MS
            - MQ
            - MU
            - MW
            - MY
            - YT
            - NA
            - NC
            - NE
            - NF
            - NG
            - NI
            - NU
            - NL
            - 'NO'
            - NP
            - NR
            - NZ
            - OM
            - PK
            - PA
            - PN
            - PE
            - PH
            - PW
            - PG
            - PL
            - PR
            - KP
            - PT
            - PY
            - PS
            - PF
            - QA
            - RE
            - RO
            - RU
            - RW
            - SA
            - SD
            - SN
            - SG
            - GS
            - SH
            - SJ
            - SB
            - SL
            - SV
            - SM
            - SO
            - PM
            - RS
            - SS
            - ST
            - SR
            - SK
            - SI
            - SE
            - SZ
            - SX
            - SC
            - SY
            - TC
            - TD
            - TG
            - TH
            - TJ
            - TK
            - TM
            - TL
            - TO
            - TT
            - TN
            - TR
            - TV
            - TW
            - TZ
            - UG
            - UA
            - UM
            - UY
            - US
            - UZ
            - VA
            - VC
            - VE
            - VG
            - VI
            - VN
            - VU
            - WF
            - WS
            - YE
            - ZA
            - ZM
            - ZW
          type: string
          description: |-
            Two-letter country code (ISO 3166-1 alpha-2)

            * `AW` - Aruba
            * `AF` - Afghanistan
            * `AO` - Angola
            * `AI` - Anguilla
            * `AX` - Åland Islands
            * `AL` - Albania
            * `AD` - Andorra
            * `AE` - United Arab Emirates
            * `AR` - Argentina
            * `AM` - Armenia
            * `AS` - American Samoa
            * `AQ` - Antarctica
            * `TF` - French Southern Territories
            * `AG` - Antigua and Barbuda
            * `AU` - Australia
            * `AT` - Austria
            * `AZ` - Azerbaijan
            * `BI` - Burundi
            * `BE` - Belgium
            * `BJ` - Benin
            * `BQ` - Bonaire, Sint Eustatius and Saba
            * `BF` - Burkina Faso
            * `BD` - Bangladesh
            * `BG` - Bulgaria
            * `BH` - Bahrain
            * `BS` - Bahamas
            * `BA` - Bosnia and Herzegovina
            * `BL` - Saint Barthélemy
            * `BY` - Belarus
            * `BZ` - Belize
            * `BM` - Bermuda
            * `BO` - Bolivia, Plurinational State of
            * `BR` - Brazil
            * `BB` - Barbados
            * `BN` - Brunei Darussalam
            * `BT` - Bhutan
            * `BV` - Bouvet Island
            * `BW` - Botswana
            * `CF` - Central African Republic
            * `CA` - Canada
            * `CC` - Cocos (Keeling) Islands
            * `CH` - Switzerland
            * `CL` - Chile
            * `CN` - China
            * `CI` - Côte d'Ivoire
            * `CM` - Cameroon
            * `CD` - Congo, The Democratic Republic of the
            * `CG` - Congo
            * `CK` - Cook Islands
            * `CO` - Colombia
            * `KM` - Comoros
            * `CV` - Cabo Verde
            * `CR` - Costa Rica
            * `CU` - Cuba
            * `CW` - Curaçao
            * `CX` - Christmas Island
            * `KY` - Cayman Islands
            * `CY` - Cyprus
            * `CZ` - Czechia
            * `DE` - Germany
            * `DJ` - Djibouti
            * `DM` - Dominica
            * `DK` - Denmark
            * `DO` - Dominican Republic
            * `DZ` - Algeria
            * `EC` - Ecuador
            * `EG` - Egypt
            * `ER` - Eritrea
            * `EH` - Western Sahara
            * `ES` - Spain
            * `EE` - Estonia
            * `ET` - Ethiopia
            * `FI` - Finland
            * `FJ` - Fiji
            * `FK` - Falkland Islands (Malvinas)
            * `FR` - France
            * `FO` - Faroe Islands
            * `FM` - Micronesia, Federated States of
            * `GA` - Gabon
            * `GB` - United Kingdom
            * `GE` - Georgia
            * `GG` - Guernsey
            * `GH` - Ghana
            * `GI` - Gibraltar
            * `GN` - Guinea
            * `GP` - Guadeloupe
            * `GM` - Gambia
            * `GW` - Guinea-Bissau
            * `GQ` - Equatorial Guinea
            * `GR` - Greece
            * `GD` - Grenada
            * `GL` - Greenland
            * `GT` - Guatemala
            * `GF` - French Guiana
            * `GU` - Guam
            * `GY` - Guyana
            * `HK` - Hong Kong
            * `HM` - Heard Island and McDonald Islands
            * `HN` - Honduras
            * `HR` - Croatia
            * `HT` - Haiti
            * `HU` - Hungary
            * `ID` - Indonesia
            * `IM` - Isle of Man
            * `IN` - India
            * `IO` - British Indian Ocean Territory
            * `IE` - Ireland
            * `IR` - Iran, Islamic Republic of
            * `IQ` - Iraq
            * `IS` - Iceland
            * `IL` - Israel
            * `IT` - Italy
            * `JM` - Jamaica
            * `JE` - Jersey
            * `JO` - Jordan
            * `JP` - Japan
            * `KZ` - Kazakhstan
            * `KE` - Kenya
            * `KG` - Kyrgyzstan
            * `KH` - Cambodia
            * `KI` - Kiribati
            * `KN` - Saint Kitts and Nevis
            * `KR` - Korea, Republic of
            * `KW` - Kuwait
            * `LA` - Lao People's Democratic Republic
            * `LB` - Lebanon
            * `LR` - Liberia
            * `LY` - Libya
            * `LC` - Saint Lucia
            * `LI` - Liechtenstein
            * `LK` - Sri Lanka
            * `LS` - Lesotho
            * `LT` - Lithuania
            * `LU` - Luxembourg
            * `LV` - Latvia
            * `MO` - Macao
            * `MF` - Saint Martin (French part)
            * `MA` - Morocco
            * `MC` - Monaco
            * `MD` - Moldova, Republic of
            * `MG` - Madagascar
            * `MV` - Maldives
            * `MX` - Mexico
            * `MH` - Marshall Islands
            * `MK` - North Macedonia
            * `ML` - Mali
            * `MT` - Malta
            * `MM` - Myanmar
            * `ME` - Montenegro
            * `MN` - Mongolia
            * `MP` - Northern Mariana Islands
            * `MZ` - Mozambique
            * `MR` - Mauritania
            * `MS` - Montserrat
            * `MQ` - Martinique
            * `MU` - Mauritius
            * `MW` - Malawi
            * `MY` - Malaysia
            * `YT` - Mayotte
            * `NA` - Namibia
            * `NC` - New Caledonia
            * `NE` - Niger
            * `NF` - Norfolk Island
            * `NG` - Nigeria
            * `NI` - Nicaragua
            * `NU` - Niue
            * `NL` - Netherlands
            * `NO` - Norway
            * `NP` - Nepal
            * `NR` - Nauru
            * `NZ` - New Zealand
            * `OM` - Oman
            * `PK` - Pakistan
            * `PA` - Panama
            * `PN` - Pitcairn
            * `PE` - Peru
            * `PH` - Philippines
            * `PW` - Palau
            * `PG` - Papua New Guinea
            * `PL` - Poland
            * `PR` - Puerto Rico
            * `KP` - Korea, Democratic People's Republic of
            * `PT` - Portugal
            * `PY` - Paraguay
            * `PS` - Palestine, State of
            * `PF` - French Polynesia
            * `QA` - Qatar
            * `RE` - Réunion
            * `RO` - Romania
            * `RU` - Russian Federation
            * `RW` - Rwanda
            * `SA` - Saudi Arabia
            * `SD` - Sudan
            * `SN` - Senegal
            * `SG` - Singapore
            * `GS` - South Georgia and the South Sandwich Islands
            * `SH` - Saint Helena, Ascension and Tristan da Cunha
            * `SJ` - Svalbard and Jan Mayen
            * `SB` - Solomon Islands
            * `SL` - Sierra Leone
            * `SV` - El Salvador
            * `SM` - San Marino
            * `SO` - Somalia
            * `PM` - Saint Pierre and Miquelon
            * `RS` - Serbia
            * `SS` - South Sudan
            * `ST` - Sao Tome and Principe
            * `SR` - Suriname
            * `SK` - Slovakia
            * `SI` - Slovenia
            * `SE` - Sweden
            * `SZ` - Eswatini
            * `SX` - Sint Maarten (Dutch part)
            * `SC` - Seychelles
            * `SY` - Syrian Arab Republic
            * `TC` - Turks and Caicos Islands
            * `TD` - Chad
            * `TG` - Togo
            * `TH` - Thailand
            * `TJ` - Tajikistan
            * `TK` - Tokelau
            * `TM` - Turkmenistan
            * `TL` - Timor-Leste
            * `TO` - Tonga
            * `TT` - Trinidad and Tobago
            * `TN` - Tunisia
            * `TR` - Turkey
            * `TV` - Tuvalu
            * `TW` - Taiwan, Province of China
            * `TZ` - Tanzania, United Republic of
            * `UG` - Uganda
            * `UA` - Ukraine
            * `UM` - United States Minor Outlying Islands
            * `UY` - Uruguay
            * `US` - United States
            * `UZ` - Uzbekistan
            * `VA` - Holy See (Vatican City State)
            * `VC` - Saint Vincent and the Grenadines
            * `VE` - Venezuela, Bolivarian Republic of
            * `VG` - Virgin Islands, British
            * `VI` - Virgin Islands, U.S.
            * `VN` - Viet Nam
            * `VU` - Vanuatu
            * `WF` - Wallis and Futuna
            * `WS` - Samoa
            * `YE` - Yemen
            * `ZA` - South Africa
            * `ZM` - Zambia
            * `ZW` - Zimbabwe
        line1:
          type: string
          minLength: 1
          description: Address line 1 (e.g., street, PO Box, or company name)
          maxLength: 100
        line2:
          type: string
          nullable: true
          minLength: 1
          description: Address line 2 (e.g., apartment, suite, unit, or building)
        postal_code:
          type: string
          minLength: 1
          description: ZIP or postal code
          maxLength: 20
        state:
          type: string
          nullable: true
          minLength: 1
          description: State, county, province, or region
          maxLength: 30
      required:
        - city
        - country
        - line1
        - postal_code
    LightweightInvoice:
      type: object
      properties:
        invoice_id:
          type: string
        seller:
          $ref: '#/components/schemas/Seller'
        payment_status:
          enum:
            - draft
            - voided
            - paid
            - unpaid
          description: |-
            * `draft` - draft
            * `voided` - voided
            * `paid` - paid
            * `unpaid` - unpaid
          readOnly: true
        amount:
          type: number
          format: double
          maximum: 10000000000
          minimum: -10000000000
          exclusiveMaximum: true
          exclusiveMinimum: true
          readOnly: true
        currency:
          $ref: '#/components/schemas/PricingUnit'
        cost_due:
          type: number
          format: double
          maximum: 10000000000
          minimum: 0
          exclusiveMaximum: true
          deprecated: true
        start_date:
          type: string
          format: date
          readOnly: true
        end_date:
          type: string
          format: date
          readOnly: true
        invoice_pdf:
          type: string
          format: uri
          nullable: true
          readOnly: true
        external_payment_obj_type:
          enum:
            - stripe
            - braintree
            - null
          type: string
          description: |-
            * `stripe` - Stripe
            * `braintree` - Braintree
          nullable: true
        external_payment_obj_id:
          type: string
          nullable: true
          readOnly: true
        invoice_number:
          type: string
          readOnly: true
        due_date:
          type: string
          format: date-time
          readOnly: true
          nullable: true
        issue_date:
          type: string
          format: date-time
          readOnly: true
        external_payment_obj_status:
          type: string
          nullable: true
      required:
        - amount
        - cost_due
        - currency
        - due_date
        - end_date
        - external_payment_obj_id
        - invoice_id
        - invoice_number
        - invoice_pdf
        - issue_date
        - payment_status
        - seller
        - start_date
        - external_payment_obj_type
    SubscriptionRecord:
      type: object
      properties:
        subscription_id:
          type: string
        start_date:
          type: string
          format: date-time
          description: >-
            The time the subscription starts. This will be a string in
            yyyy-mm-dd HH:mm:ss format in UTC time.
        end_date:
          type: string
          format: date-time
          description: >-
            The time the subscription starts. This will be a string in
            yyyy-mm-dd HH:mm:ss format in UTC time.
        auto_renew:
          type: boolean
          description: Whether the subscription automatically renews. Defaults to true.
        is_new:
          type: boolean
          description: >-
            Whether this subscription came from a renewal or from a first-time.
            Defaults to true on creation.
        subscription_filters:
          type: array
          items:
            $ref: '#/components/schemas/SubscriptionFilter'
        customer:
          $ref: '#/components/schemas/LightweightCustomer'
        billing_plan:
          $ref: '#/components/schemas/LightweightPlanVersion'
        fully_billed:
          type: boolean
          readOnly: true
        addons:
          type: array
          items:
            $ref: '#/components/schemas/LightweightAddOnSubscriptionRecord'
        metadata:
          type: object
          additionalProperties: {}
      required:
        - addons
        - auto_renew
        - billing_plan
        - customer
        - end_date
        - fully_billed
        - is_new
        - metadata
        - start_date
        - subscription_filters
        - subscription_id
    CustomerIntegrations:
      type: object
      properties:
        stripe:
          allOf:
            - $ref: '#/components/schemas/CustomerStripeIntegration'
          nullable: true
        braintree:
          allOf:
            - $ref: '#/components/schemas/CustomerBraintreeIntegration'
          nullable: true
    PricingUnit:
      type: object
      properties:
        code:
          type: string
          maxLength: 10
        name:
          type: string
          maxLength: 100
        symbol:
          type: string
          maxLength: 10
      required:
        - code
        - name
        - symbol
    Address:
      type: object
      properties:
        city:
          type: string
          description: City, district, suburb, town, or village
          maxLength: 50
        country:
          enum:
            - AW
            - AF
            - AO
            - AI
            - AX
            - AL
            - AD
            - AE
            - AR
            - AM
            - AS
            - AQ
            - TF
            - AG
            - AU
            - AT
            - AZ
            - BI
            - BE
            - BJ
            - BQ
            - BF
            - BD
            - BG
            - BH
            - BS
            - BA
            - BL
            - BY
            - BZ
            - BM
            - BO
            - BR
            - BB
            - BN
            - BT
            - BV
            - BW
            - CF
            - CA
            - CC
            - CH
            - CL
            - CN
            - CI
            - CM
            - CD
            - CG
            - CK
            - CO
            - KM
            - CV
            - CR
            - CU
            - CW
            - CX
            - KY
            - CY
            - CZ
            - DE
            - DJ
            - DM
            - DK
            - DO
            - DZ
            - EC
            - EG
            - ER
            - EH
            - ES
            - EE
            - ET
            - FI
            - FJ
            - FK
            - FR
            - FO
            - FM
            - GA
            - GB
            - GE
            - GG
            - GH
            - GI
            - GN
            - GP
            - GM
            - GW
            - GQ
            - GR
            - GD
            - GL
            - GT
            - GF
            - GU
            - GY
            - HK
            - HM
            - HN
            - HR
            - HT
            - HU
            - ID
            - IM
            - IN
            - IO
            - IE
            - IR
            - IQ
            - IS
            - IL
            - IT
            - JM
            - JE
            - JO
            - JP
            - KZ
            - KE
            - KG
            - KH
            - KI
            - KN
            - KR
            - KW
            - LA
            - LB
            - LR
            - LY
            - LC
            - LI
            - LK
            - LS
            - LT
            - LU
            - LV
            - MO
            - MF
            - MA
            - MC
            - MD
            - MG
            - MV
            - MX
            - MH
            - MK
            - ML
            - MT
            - MM
            - ME
            - MN
            - MP
            - MZ
            - MR
            - MS
            - MQ
            - MU
            - MW
            - MY
            - YT
            - NA
            - NC
            - NE
            - NF
            - NG
            - NI
            - NU
            - NL
            - 'NO'
            - NP
            - NR
            - NZ
            - OM
            - PK
            - PA
            - PN
            - PE
            - PH
            - PW
            - PG
            - PL
            - PR
            - KP
            - PT
            - PY
            - PS
            - PF
            - QA
            - RE
            - RO
            - RU
            - RW
            - SA
            - SD
            - SN
            - SG
            - GS
            - SH
            - SJ
            - SB
            - SL
            - SV
            - SM
            - SO
            - PM
            - RS
            - SS
            - ST
            - SR
            - SK
            - SI
            - SE
            - SZ
            - SX
            - SC
            - SY
            - TC
            - TD
            - TG
            - TH
            - TJ
            - TK
            - TM
            - TL
            - TO
            - TT
            - TN
            - TR
            - TV
            - TW
            - TZ
            - UG
            - UA
            - UM
            - UY
            - US
            - UZ
            - VA
            - VC
            - VE
            - VG
            - VI
            - VN
            - VU
            - WF
            - WS
            - YE
            - ZA
            - ZM
            - ZW
          type: string
          description: |-
            Two-letter country code (ISO 3166-1 alpha-2)

            * `AW` - Aruba
            * `AF` - Afghanistan
            * `AO` - Angola
            * `AI` - Anguilla
            * `AX` - Åland Islands
            * `AL` - Albania
            * `AD` - Andorra
            * `AE` - United Arab Emirates
            * `AR` - Argentina
            * `AM` - Armenia
            * `AS` - American Samoa
            * `AQ` - Antarctica
            * `TF` - French Southern Territories
            * `AG` - Antigua and Barbuda
            * `AU` - Australia
            * `AT` - Austria
            * `AZ` - Azerbaijan
            * `BI` - Burundi
            * `BE` - Belgium
            * `BJ` - Benin
            * `BQ` - Bonaire, Sint Eustatius and Saba
            * `BF` - Burkina Faso
            * `BD` - Bangladesh
            * `BG` - Bulgaria
            * `BH` - Bahrain
            * `BS` - Bahamas
            * `BA` - Bosnia and Herzegovina
            * `BL` - Saint Barthélemy
            * `BY` - Belarus
            * `BZ` - Belize
            * `BM` - Bermuda
            * `BO` - Bolivia, Plurinational State of
            * `BR` - Brazil
            * `BB` - Barbados
            * `BN` - Brunei Darussalam
            * `BT` - Bhutan
            * `BV` - Bouvet Island
            * `BW` - Botswana
            * `CF` - Central African Republic
            * `CA` - Canada
            * `CC` - Cocos (Keeling) Islands
            * `CH` - Switzerland
            * `CL` - Chile
            * `CN` - China
            * `CI` - Côte d'Ivoire
            * `CM` - Cameroon
            * `CD` - Congo, The Democratic Republic of the
            * `CG` - Congo
            * `CK` - Cook Islands
            * `CO` - Colombia
            * `KM` - Comoros
            * `CV` - Cabo Verde
            * `CR` - Costa Rica
            * `CU` - Cuba
            * `CW` - Curaçao
            * `CX` - Christmas Island
            * `KY` - Cayman Islands
            * `CY` - Cyprus
            * `CZ` - Czechia
            * `DE` - Germany
            * `DJ` - Djibouti
            * `DM` - Dominica
            * `DK` - Denmark
            * `DO` - Dominican Republic
            * `DZ` - Algeria
            * `EC` - Ecuador
            * `EG` - Egypt
            * `ER` - Eritrea
            * `EH` - Western Sahara
            * `ES` - Spain
            * `EE` - Estonia
            * `ET` - Ethiopia
            * `FI` - Finland
            * `FJ` - Fiji
            * `FK` - Falkland Islands (Malvinas)
            * `FR` - France
            * `FO` - Faroe Islands
            * `FM` - Micronesia, Federated States of
            * `GA` - Gabon
            * `GB` - United Kingdom
            * `GE` - Georgia
            * `GG` - Guernsey
            * `GH` - Ghana
            * `GI` - Gibraltar
            * `GN` - Guinea
            * `GP` - Guadeloupe
            * `GM` - Gambia
            * `GW` - Guinea-Bissau
            * `GQ` - Equatorial Guinea
            * `GR` - Greece
            * `GD` - Grenada
            * `GL` - Greenland
            * `GT` - Guatemala
            * `GF` - French Guiana
            * `GU` - Guam
            * `GY` - Guyana
            * `HK` - Hong Kong
            * `HM` - Heard Island and McDonald Islands
            * `HN` - Honduras
            * `HR` - Croatia
            * `HT` - Haiti
            * `HU` - Hungary
            * `ID` - Indonesia
            * `IM` - Isle of Man
            * `IN` - India
            * `IO` - British Indian Ocean Territory
            * `IE` - Ireland
            * `IR` - Iran, Islamic Republic of
            * `IQ` - Iraq
            * `IS` - Iceland
            * `IL` - Israel
            * `IT` - Italy
            * `JM` - Jamaica
            * `JE` - Jersey
            * `JO` - Jordan
            * `JP` - Japan
            * `KZ` - Kazakhstan
            * `KE` - Kenya
            * `KG` - Kyrgyzstan
            * `KH` - Cambodia
            * `KI` - Kiribati
            * `KN` - Saint Kitts and Nevis
            * `KR` - Korea, Republic of
            * `KW` - Kuwait
            * `LA` - Lao People's Democratic Republic
            * `LB` - Lebanon
            * `LR` - Liberia
            * `LY` - Libya
            * `LC` - Saint Lucia
            * `LI` - Liechtenstein
            * `LK` - Sri Lanka
            * `LS` - Lesotho
            * `LT` - Lithuania
            * `LU` - Luxembourg
            * `LV` - Latvia
            * `MO` - Macao
            * `MF` - Saint Martin (French part)
            * `MA` - Morocco
            * `MC` - Monaco
            * `MD` - Moldova, Republic of
            * `MG` - Madagascar
            * `MV` - Maldives
            * `MX` - Mexico
            * `MH` - Marshall Islands
            * `MK` - North Macedonia
            * `ML` - Mali
            * `MT` - Malta
            * `MM` - Myanmar
            * `ME` - Montenegro
            * `MN` - Mongolia
            * `MP` - Northern Mariana Islands
            * `MZ` - Mozambique
            * `MR` - Mauritania
            * `MS` - Montserrat
            * `MQ` - Martinique
            * `MU` - Mauritius
            * `MW` - Malawi
            * `MY` - Malaysia
            * `YT` - Mayotte
            * `NA` - Namibia
            * `NC` - New Caledonia
            * `NE` - Niger
            * `NF` - Norfolk Island
            * `NG` - Nigeria
            * `NI` - Nicaragua
            * `NU` - Niue
            * `NL` - Netherlands
            * `NO` - Norway
            * `NP` - Nepal
            * `NR` - Nauru
            * `NZ` - New Zealand
            * `OM` - Oman
            * `PK` - Pakistan
            * `PA` - Panama
            * `PN` - Pitcairn
            * `PE` - Peru
            * `PH` - Philippines
            * `PW` - Palau
            * `PG` - Papua New Guinea
            * `PL` - Poland
            * `PR` - Puerto Rico
            * `KP` - Korea, Democratic People's Republic of
            * `PT` - Portugal
            * `PY` - Paraguay
            * `PS` - Palestine, State of
            * `PF` - French Polynesia
            * `QA` - Qatar
            * `RE` - Réunion
            * `RO` - Romania
            * `RU` - Russian Federation
            * `RW` - Rwanda
            * `SA` - Saudi Arabia
            * `SD` - Sudan
            * `SN` - Senegal
            * `SG` - Singapore
            * `GS` - South Georgia and the South Sandwich Islands
            * `SH` - Saint Helena, Ascension and Tristan da Cunha
            * `SJ` - Svalbard and Jan Mayen
            * `SB` - Solomon Islands
            * `SL` - Sierra Leone
            * `SV` - El Salvador
            * `SM` - San Marino
            * `SO` - Somalia
            * `PM` - Saint Pierre and Miquelon
            * `RS` - Serbia
            * `SS` - South Sudan
            * `ST` - Sao Tome and Principe
            * `SR` - Suriname
            * `SK` - Slovakia
            * `SI` - Slovenia
            * `SE` - Sweden
            * `SZ` - Eswatini
            * `SX` - Sint Maarten (Dutch part)
            * `SC` - Seychelles
            * `SY` - Syrian Arab Republic
            * `TC` - Turks and Caicos Islands
            * `TD` - Chad
            * `TG` - Togo
            * `TH` - Thailand
            * `TJ` - Tajikistan
            * `TK` - Tokelau
            * `TM` - Turkmenistan
            * `TL` - Timor-Leste
            * `TO` - Tonga
            * `TT` - Trinidad and Tobago
            * `TN` - Tunisia
            * `TR` - Turkey
            * `TV` - Tuvalu
            * `TW` - Taiwan, Province of China
            * `TZ` - Tanzania, United Republic of
            * `UG` - Uganda
            * `UA` - Ukraine
            * `UM` - United States Minor Outlying Islands
            * `UY` - Uruguay
            * `US` - United States
            * `UZ` - Uzbekistan
            * `VA` - Holy See (Vatican City State)
            * `VC` - Saint Vincent and the Grenadines
            * `VE` - Venezuela, Bolivarian Republic of
            * `VG` - Virgin Islands, British
            * `VI` - Virgin Islands, U.S.
            * `VN` - Viet Nam
            * `VU` - Vanuatu
            * `WF` - Wallis and Futuna
            * `WS` - Samoa
            * `YE` - Yemen
            * `ZA` - South Africa
            * `ZM` - Zambia
            * `ZW` - Zimbabwe
        line1:
          type: string
          description: Address line 1 (e.g., street, PO Box, or company name)
          maxLength: 100
        line2:
          type: string
          nullable: true
          description: Address line 2 (e.g., apartment, suite, unit, or building)
        postal_code:
          type: string
          description: ZIP or postal code
          maxLength: 20
        state:
          type: string
          nullable: true
          description: State, county, province, or region
          maxLength: 30
      required:
        - city
        - country
        - line1
        - postal_code
    Seller:
      type: object
      properties:
        name:
          type: string
        address:
          allOf:
            - $ref: '#/components/schemas/Address'
          nullable: true
          readOnly: true
        phone:
          type: string
          nullable: true
          maxLength: 20
        email:
          type: string
          format: email
          nullable: true
          maxLength: 254
      required:
        - name
    SubscriptionFilter:
      type: object
      properties:
        value:
          type: string
        property_name:
          type: string
          description: 'The string name of the property to filter on. Example: ''product_id'''
      required:
        - property_name
        - value
    LightweightCustomer:
      type: object
      properties:
        customer_name:
          type: string
          readOnly: true
          nullable: true
          description: The display name of the customer
        email:
          type: string
          format: email
          readOnly: true
          nullable: true
          description: >-
            The primary email address of the customer, must be the same as the
            email address used to create the customer in the payment provider
        customer_id:
          type: string
          readOnly: true
          nullable: true
          description: >-
            The id provided when creating the customer, we suggest matching with
            your internal customer id in your backend
      required:
        - customer_id
        - customer_name
        - email
    LightweightPlanVersion:
      type: object
      properties:
        plan_name:
          type: string
          readOnly: true
        plan_id:
          type: string
        version_id:
          type: string
          readOnly: true
        version:
          oneOf:
            - type: integer
            - enum:
                - custom_version
              type: string
          readOnly: true
      required:
        - plan_id
        - plan_name
        - version
        - version_id
    LightweightAddOnSubscriptionRecord:
      type: object
      properties:
        addon_subscription_id:
          type: string
        start_date:
          type: string
          format: date-time
          readOnly: true
          description: >-
            The time the subscription starts. This will be a string in
            yyyy-mm-dd HH:mm:ss format in UTC time.
        end_date:
          type: string
          format: date-time
          readOnly: true
          description: >-
            The time the subscription starts. This will be a string in
            yyyy-mm-dd HH:mm:ss format in UTC time.
        addon:
          $ref: '#/components/schemas/LightweightAddOn'
        fully_billed:
          type: boolean
          readOnly: true
      required:
        - addon
        - addon_subscription_id
        - end_date
        - fully_billed
        - start_date
    CustomerStripeIntegration:
      type: object
      properties:
        stripe_id:
          type: string
        has_payment_method:
          type: boolean
      required:
        - has_payment_method
        - stripe_id
    CustomerBraintreeIntegration:
      type: object
      properties:
        braintree_id:
          type: string
        has_payment_method:
          type: boolean
      required:
        - braintree_id
        - has_payment_method
    LightweightAddOn:
      type: object
      properties:
        addon_name:
          type: string
          description: The name of the add-on plan.
        addon_id:
          type: string
          description: The ID of the add-on plan.
        addon_type:
          enum:
            - flat
            - usage_based
          type: string
          readOnly: true
        billing_frequency:
          enum:
            - one_time
            - recurring
          description: |-
            * `one_time` - one_time
            * `recurring` - recurring
          readOnly: true
      required:
        - addon_id
        - addon_name
        - addon_type
        - billing_frequency
  securitySchemes:
    knoxTokenAuth:
      type: apiKey
      in: header
      name: Authorization
      description: Token-based authentication with required prefix "Token"
    OrganizationApiKeyAuth:
      type: apiKey
      in: header
      name: X-API-KEY

````